package org.dromara.personnel.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.personnel.domain.bo.OpsBeipinBeijianBo;
import org.dromara.personnel.domain.dto.OpsBeipinBeijianDto;
import org.dromara.personnel.domain.vo.OpsBeipinBeijianVo;
import org.springframework.stereotype.Service;
import org.dromara.personnel.domain.bo.OpsCaigouPlanChanpinBo;
import org.dromara.personnel.domain.vo.OpsCaigouPlanChanpinVo;
import org.dromara.personnel.domain.OpsCaigouPlanChanpin;
import org.dromara.personnel.mapper.OpsCaigouPlanChanpinMapper;
import org.dromara.personnel.service.IOpsCaigouPlanChanpinService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维-物资-采购申请计划-产品信息Service业务层处理
 *
 * @author LionLi
 * @date 2025-09-24
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsCaigouPlanChanpinServiceImpl extends ServiceImpl<OpsCaigouPlanChanpinMapper,OpsCaigouPlanChanpin>  implements IOpsCaigouPlanChanpinService {

    private final OpsCaigouPlanChanpinMapper baseMapper;

    /**
     * 查询运维-物资-采购申请计划-产品信息
     *
     * @param id 主键
     * @return 运维-物资-采购申请计划-产品信息
     */
    @Override
    public OpsCaigouPlanChanpinVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询运维-物资-采购申请计划-产品信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维-物资-采购申请计划-产品信息分页列表
     */
    @Override
    public TableDataInfo<OpsCaigouPlanChanpinVo> queryPageList(OpsCaigouPlanChanpinBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsCaigouPlanChanpin> lqw = buildQueryWrapper(bo);
        Page<OpsCaigouPlanChanpinVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维-物资-采购申请计划-产品信息列表
     *
     * @param bo 查询条件
     * @return 运维-物资-采购申请计划-产品信息列表
     */
    @Override
    public List<OpsCaigouPlanChanpinVo> queryList(OpsCaigouPlanChanpinBo bo) {
        LambdaQueryWrapper<OpsCaigouPlanChanpin> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsCaigouPlanChanpin> buildQueryWrapper(OpsCaigouPlanChanpinBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsCaigouPlanChanpin> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsCaigouPlanChanpin::getId);
        lqw.eq(bo.getCaigouPlanId() != null, OpsCaigouPlanChanpin::getCaigouPlanId, bo.getCaigouPlanId());
        lqw.like(StringUtils.isNotBlank(bo.getChanpinName()), OpsCaigouPlanChanpin::getChanpinName, bo.getChanpinName());
        lqw.eq(StringUtils.isNotBlank(bo.getChanpinType()), OpsCaigouPlanChanpin::getChanpinType, bo.getChanpinType());
        lqw.eq(bo.getChanpinMonovalent() != null, OpsCaigouPlanChanpin::getChanpinMonovalent, bo.getChanpinMonovalent());
        lqw.eq(bo.getGoumaiNumber() != null, OpsCaigouPlanChanpin::getGoumaiNumber, bo.getGoumaiNumber());
        lqw.eq(StringUtils.isNotBlank(bo.getDanwei()), OpsCaigouPlanChanpin::getDanwei, bo.getDanwei());
        lqw.eq(StringUtils.isNotBlank(bo.getYontu()), OpsCaigouPlanChanpin::getYontu, bo.getYontu());
        return lqw;
    }

    /**
     * 新增运维-物资-采购申请计划-产品信息
     *
     * @param bo 运维-物资-采购申请计划-产品信息
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsCaigouPlanChanpinBo bo) {
        OpsCaigouPlanChanpin add = MapstructUtils.convert(bo, OpsCaigouPlanChanpin.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改运维-物资-采购申请计划-产品信息
     *
     * @param bo 运维-物资-采购申请计划-产品信息
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsCaigouPlanChanpinBo bo) {
        OpsCaigouPlanChanpin update = MapstructUtils.convert(bo, OpsCaigouPlanChanpin.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsCaigouPlanChanpin entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维-物资-采购申请计划-产品信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    @Override
    public List<OpsCaigouPlanChanpinVo> getVoByCaiGouPlanId(Long caigouId) {
        return baseMapper.selectVoList(new LambdaQueryWrapper<OpsCaigouPlanChanpin>().eq(OpsCaigouPlanChanpin::getCaigouPlanId, caigouId));
    }

    @Override
    public Page<OpsBeipinBeijianDto> getBeiJianList(IPage<OpsBeipinBeijianDto> build, OpsBeipinBeijianBo bo) {
        return baseMapper.getBeiJianList(build,bo);
    }

    @Override
    public List<OpsBeipinBeijianDto> getCount(OpsBeipinBeijianBo bo) {
        return baseMapper.getCount(bo.getProjectId());
    }

}
